#ifndef __REALMSCENEELEVATIONMAP_H
	#define __REALMSCENEELEVATIONMAP_H

#include "RealmNumberGenerator.h"
#include "RealmMapKey.h"

class RealmColorMap;
class RealmSceneElevationMapRepository;

class RealmSceneElevationMap {
private:
	unsigned long MapSeed;
	RealmColorMap* ColorMap;

	// array to be allocated based on size parameter passed through constructor
	int* ElevationSpiral;


	void updateColorMapHex(int hexindex, bool first_display);
	void populateColorMap();

protected:

	RealmMapKey MapKey;
	int MapSize;

	RealmSceneElevationMapRepository* MapRepository;
	RealmNumberGenerator NumGenerator;

	int setElevation(int hexindex, int value);

	// virtual int getBaseVariance();

public:
	RealmSceneElevationMap(RealmSceneElevationMapRepository* maprepo, RealmMapKey mapkey, int mapsize);
	virtual ~RealmSceneElevationMap();

	int getElevation(int spiralidx);

	RealmMapKey getMapKey() { return MapKey; }

	// retrieves elevation from any index, pulling data from beyond the map edge if needed
	virtual int findElevation(long int spiralidx) = 0;

	virtual RealmSceneElevationMap* getCenterMap() = 0;


	void attachColorMap(RealmColorMap* cp);
	void detachColorMap();

	virtual bool isInverted() = 0;

	unsigned long getChildSeed(int spiralidx);
	unsigned long getSubSeed(int spiralidx) ;

	virtual void populate() = 0;

	virtual void populateStep() = 0;

	virtual void populateToStep(int step) = 0;
	virtual void populateNeighborStep() = 0;
};

#endif // __REALMSCENEELEVATIONMAP_H
