#ifndef __REALMTERRAIN_H
	#define __REALMTERRIAN_H

#include "RealmLocation.h"
#include "RealmSceneObject.h"

#include "SceneObjectCollection.h"
#include "RealmObjectCollection.h"

#include "WorldObjectCollection.h"
#include "RealmObjectType.h"
#include "RealmWorldObject.h"
#include "RealmSceneElevationMapRepository.h"
#include "RealmSceneBackgroundRepository.h"

class RealmSceneView;

class RealmTerrain {
	private:

	// not complete or used yet, but possibly soon.....
	enum {
		TERRAIN_BLANK = 0,
		TERRAIN_DIRT,
		TERRAIN_GRASS,
		TERRAIN_ROCKY,
		TERRAIN_SAND,
		TERRAIN_DESERT,
		TERRAIN_SWAMP,
		TERRAIN_WATER_SHALLOW,
		TERRAIN_WATER_MEDIUM,
		TERRAIN_WATER_DEEP
	};


		RealmSceneElevationMapRepository MapRepository;
		RealmSceneBackgroundRepository BackgroundRepository;

		RealmObjectType treetype;
		RealmObjectType spiraltype;
		// RealmObjectType cursortype;

		// initial test : hardcoded scenes + objects

		WorldObjectCollection worldobjects;
		RealmObjectCollection scenerepo;

		SceneObjectCollection SceneObjects;


		RealmWorldObject worldtree1;
		RealmWorldObject worldspiral1;

		int foresttreecount;
		RealmSceneObject* scene1trees;

		RealmSceneObject testtree;
		RealmSceneObject testtree2;
		RealmSceneObject bigtree1;
		RealmSceneObject bigtree2;
		RealmSceneObject bigtree3;
		RealmSceneObject bigtree4;
		RealmSceneObject testspiral;

		// RealmSceneObject keycursor;

		void updateObjectCollection(int view_level, RealmLocation view_center);
	public:
		RealmTerrain();

		void init(int base_radius);
		void cleanup();

		// injects the set of objects + elevation map at view_center (level view_level) into a RealmSceneView
		void updateScene(int view_level, RealmLocation view_center, RealmSceneView* rsv);

		// RealmSceneObject* getCursor() { return &keycursor; }

		RealmSceneElevationMapRepository* getMapRepository() { return &MapRepository; }

		// void autoMove();

		void update();
		void draw(SDL_Renderer* renderer);
};


#endif // __REALMTERRAIN_H
