#include "SceneObjectCollection.h"
#include "RealmSceneView.h"
#include "RealmSceneObject.h"
#include "RealmWorldObject.h"
#include "RealmSceneObject.h"
#include "RealmSceneObjectPositioner.h"
#include "RealmWorldObjectScenePositioner.h"


SceneObjectCollection::SceneObjectCollection() {
	object_count = 0;
	realm_scene_view = nullptr;
}

void SceneObjectCollection::addObject(RealmSceneObject* object) {
	objects.push_front(object);
	object_count++;
}

void SceneObjectCollection::addWorldObject(RealmWorldObject* object) {
	world_objects.push_front(object);
}

void SceneObjectCollection::clearWorldObjects() {
	world_objects.clear();
}

void SceneObjectCollection::updateRealmSceneView(RealmSceneView* rsv)
{
	RealmSceneObjectPositioner* object_animator;
	RealmWorldObjectScenePositioner* world_object_animator;
	if (realm_scene_view != rsv) {
		realm_scene_view = rsv;
		for (RealmSceneObject* &o : objects) {
			object_animator = new RealmSceneObjectPositioner(rsv, o->getSceneCoordinate() );
			o->setObjectPositioner(object_animator);

		}
		for (RealmWorldObject* &o : world_objects) {
			world_object_animator = new RealmWorldObjectScenePositioner(o, rsv );
			o->setObjectPositioner(world_object_animator);

			o->setRealmSceneView(rsv);
		}
	}
}

void SceneObjectCollection::drawObjects(SDL_Renderer* renderer) {
	for (RealmSceneObject* &o : objects) {
		o->draw(renderer);
	}
	for (RealmWorldObject* &o : world_objects) {
		o->draw(renderer);
	}
}

