#include "WorldObjectCollection.h"
#include <algorithm>
#include <vector>
#include "RealmWorldObject.h"

void WorldObjectCollection::addObject(RealmWorldObject* o) {
	YIndexedObjects.insert(std::pair<long, RealmWorldObject*> (o->getRealmWorldLocation().gety(), o) );
	XIndexedObjects.insert(std::pair<long, RealmWorldObject*> (o->getRealmWorldLocation().getx(), o) );
	WorldObjects.push_front(o);
}

void WorldObjectCollection::getRange(long minx, long miny, long maxx, long maxy,
									 std::vector<RealmWorldObject*> &result_set
									 )
{
	std::multimap<long, RealmWorldObject*>::iterator it, xlow, ylow, xhigh, yhigh;

	std::vector<RealmWorldObject*> xranged_object_collection;
	std::vector<RealmWorldObject*> yranged_object_collection;

	xlow = XIndexedObjects.lower_bound(minx);
	xhigh = XIndexedObjects.upper_bound(maxx);
	ylow = YIndexedObjects.lower_bound(miny);
	yhigh = YIndexedObjects.upper_bound(maxy);

	for (it = xlow; it != xhigh; it++) {
		xranged_object_collection.push_back((*it).second);
	}
	for (it = ylow; it != yhigh; it++) {
		yranged_object_collection.push_back((*it).second);
	}

	std::sort(xranged_object_collection.begin(), xranged_object_collection.end());
	std::sort(yranged_object_collection.begin(), yranged_object_collection.end());

	std::set_intersection(
		xranged_object_collection.begin(), xranged_object_collection.end(),
		yranged_object_collection.begin(), yranged_object_collection.end(),
		std::back_inserter(result_set)
	);

}


